git-rebase.shon commit Merge branch 'tr/submodule-relative-scp-url' into maint (8a59702)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .git/rebase-apply working files, use the
  18command git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.
  22
  23Example:       git-rebase master~1 topic
  24
  25        A---B---C topic                   A'\''--B'\''--C'\'' topic
  26       /                   -->           /
  27  D---E---F---G master          D---E---F---G master
  28'
  29
  30SUBDIRECTORY_OK=Yes
  31OPTIONS_SPEC=
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37LF='
  38'
  39OK_TO_SKIP_PRE_REBASE=
  40RESOLVEMSG="
  41When you have resolved this problem run \"git rebase --continue\".
  42If you would prefer to skip this patch, instead run \"git rebase --skip\".
  43To restore the original branch and stop rebasing run \"git rebase --abort\".
  44"
  45unset newbase
  46strategy=recursive
  47strategy_opts=
  48do_merge=
  49dotest="$GIT_DIR"/rebase-merge
  50prec=4
  51verbose=
  52diffstat=
  53test "$(git config --bool rebase.stat)" = true && diffstat=t
  54git_am_opt=
  55rebase_root=
  56force_rebase=
  57allow_rerere_autoupdate=
  58
  59continue_merge () {
  60        test -n "$prev_head" || die "prev_head must be defined"
  61        test -d "$dotest" || die "$dotest directory does not exist"
  62
  63        unmerged=$(git ls-files -u)
  64        if test -n "$unmerged"
  65        then
  66                echo "You still have unmerged paths in your index"
  67                echo "did you forget to use git add?"
  68                die "$RESOLVEMSG"
  69        fi
  70
  71        cmt=`cat "$dotest/current"`
  72        if ! git diff-index --quiet --ignore-submodules HEAD --
  73        then
  74                if ! git commit --no-verify -C "$cmt"
  75                then
  76                        echo "Commit failed, please do not call \"git commit\""
  77                        echo "directly, but instead do one of the following: "
  78                        die "$RESOLVEMSG"
  79                fi
  80                if test -z "$GIT_QUIET"
  81                then
  82                        printf "Committed: %0${prec}d " $msgnum
  83                fi
  84                echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
  85        else
  86                if test -z "$GIT_QUIET"
  87                then
  88                        printf "Already applied: %0${prec}d " $msgnum
  89                fi
  90        fi
  91        test -z "$GIT_QUIET" &&
  92        GIT_PAGER='' git log --format=%s -1 "$cmt"
  93
  94        prev_head=`git rev-parse HEAD^0`
  95        # save the resulting commit so we can read-tree on it later
  96        echo "$prev_head" > "$dotest/prev_head"
  97
  98        # onto the next patch:
  99        msgnum=$(($msgnum + 1))
 100        echo "$msgnum" >"$dotest/msgnum"
 101}
 102
 103call_merge () {
 104        cmt="$(cat "$dotest/cmt.$1")"
 105        echo "$cmt" > "$dotest/current"
 106        hd=$(git rev-parse --verify HEAD)
 107        cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
 108        msgnum=$(cat "$dotest/msgnum")
 109        end=$(cat "$dotest/end")
 110        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
 111        eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
 112        export GITHEAD_$cmt GITHEAD_$hd
 113        if test -n "$GIT_QUIET"
 114        then
 115                GIT_MERGE_VERBOSITY=1 && export GIT_MERGE_VERBOSITY
 116        fi
 117        eval 'git-merge-$strategy' $strategy_opts '"$cmt^" -- "$hd" "$cmt"'
 118        rv=$?
 119        case "$rv" in
 120        0)
 121                unset GITHEAD_$cmt GITHEAD_$hd
 122                return
 123                ;;
 124        1)
 125                git rerere $allow_rerere_autoupdate
 126                die "$RESOLVEMSG"
 127                ;;
 128        2)
 129                echo "Strategy: $rv $strategy failed, try another" 1>&2
 130                die "$RESOLVEMSG"
 131                ;;
 132        *)
 133                die "Unknown exit code ($rv) from command:" \
 134                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 135                ;;
 136        esac
 137}
 138
 139move_to_original_branch () {
 140        test -z "$head_name" &&
 141                head_name="$(cat "$dotest"/head-name)" &&
 142                onto="$(cat "$dotest"/onto)" &&
 143                orig_head="$(cat "$dotest"/orig-head)"
 144        case "$head_name" in
 145        refs/*)
 146                message="rebase finished: $head_name onto $onto"
 147                git update-ref -m "$message" \
 148                        $head_name $(git rev-parse HEAD) $orig_head &&
 149                git symbolic-ref HEAD $head_name ||
 150                die "Could not move back to $head_name"
 151                ;;
 152        esac
 153}
 154
 155finish_rb_merge () {
 156        move_to_original_branch
 157        git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 158        if test -x "$GIT_DIR"/hooks/post-rewrite &&
 159                test -s "$dotest"/rewritten; then
 160                "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 161        fi
 162        rm -r "$dotest"
 163        say All done.
 164}
 165
 166is_interactive () {
 167        while test $# != 0
 168        do
 169                case "$1" in
 170                        -i|--interactive)
 171                                interactive_rebase=explicit
 172                                break
 173                        ;;
 174                        -p|--preserve-merges)
 175                                interactive_rebase=implied
 176                        ;;
 177                esac
 178                shift
 179        done
 180
 181        if [ "$interactive_rebase" = implied ]; then
 182                GIT_EDITOR=:
 183                export GIT_EDITOR
 184        fi
 185
 186        test -n "$interactive_rebase" || test -f "$dotest"/interactive
 187}
 188
 189run_pre_rebase_hook () {
 190        if test -z "$OK_TO_SKIP_PRE_REBASE" &&
 191           test -x "$GIT_DIR/hooks/pre-rebase"
 192        then
 193                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
 194                die "The pre-rebase hook refused to rebase."
 195        fi
 196}
 197
 198test -f "$GIT_DIR"/rebase-apply/applying &&
 199        die 'It looks like git-am is in progress. Cannot rebase.'
 200
 201is_interactive "$@" && exec git-rebase--interactive "$@"
 202
 203while test $# != 0
 204do
 205        case "$1" in
 206        --no-verify)
 207                OK_TO_SKIP_PRE_REBASE=yes
 208                ;;
 209        --continue)
 210                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 211                        die "No rebase in progress?"
 212
 213                git update-index --ignore-submodules --refresh &&
 214                git diff-files --quiet --ignore-submodules || {
 215                        echo "You must edit all merge conflicts and then"
 216                        echo "mark them as resolved using git add"
 217                        exit 1
 218                }
 219                if test -d "$dotest"
 220                then
 221                        prev_head=$(cat "$dotest/prev_head")
 222                        end=$(cat "$dotest/end")
 223                        msgnum=$(cat "$dotest/msgnum")
 224                        onto=$(cat "$dotest/onto")
 225                        GIT_QUIET=$(cat "$dotest/quiet")
 226                        continue_merge
 227                        while test "$msgnum" -le "$end"
 228                        do
 229                                call_merge "$msgnum"
 230                                continue_merge
 231                        done
 232                        finish_rb_merge
 233                        exit
 234                fi
 235                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 236                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 237                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 238                GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
 239                git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
 240                move_to_original_branch
 241                exit
 242                ;;
 243        --skip)
 244                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 245                        die "No rebase in progress?"
 246
 247                git reset --hard HEAD || exit $?
 248                if test -d "$dotest"
 249                then
 250                        git rerere clear
 251                        prev_head=$(cat "$dotest/prev_head")
 252                        end=$(cat "$dotest/end")
 253                        msgnum=$(cat "$dotest/msgnum")
 254                        msgnum=$(($msgnum + 1))
 255                        onto=$(cat "$dotest/onto")
 256                        GIT_QUIET=$(cat "$dotest/quiet")
 257                        while test "$msgnum" -le "$end"
 258                        do
 259                                call_merge "$msgnum"
 260                                continue_merge
 261                        done
 262                        finish_rb_merge
 263                        exit
 264                fi
 265                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 266                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 267                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 268                GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
 269                git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
 270                move_to_original_branch
 271                exit
 272                ;;
 273        --abort)
 274                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 275                        die "No rebase in progress?"
 276
 277                git rerere clear
 278
 279                test -d "$dotest" || dotest="$GIT_DIR"/rebase-apply
 280
 281                head_name="$(cat "$dotest"/head-name)" &&
 282                case "$head_name" in
 283                refs/*)
 284                        git symbolic-ref HEAD $head_name ||
 285                        die "Could not move back to $head_name"
 286                        ;;
 287                esac
 288                git reset --hard $(cat "$dotest/orig-head")
 289                rm -r "$dotest"
 290                exit
 291                ;;
 292        --onto)
 293                test 2 -le "$#" || usage
 294                newbase="$2"
 295                shift
 296                ;;
 297        -M|-m|--m|--me|--mer|--merg|--merge)
 298                do_merge=t
 299                ;;
 300        -X*|--strategy-option*)
 301                case "$#,$1" in
 302                1,-X|1,--strategy-option)
 303                        usage ;;
 304                *,-X|*,--strategy-option)
 305                        newopt="$2"
 306                        shift ;;
 307                *,--strategy-option=*)
 308                        newopt="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
 309                *,-X*)
 310                        newopt="$(expr " $1" : ' -X\(.*\)')" ;;
 311                1,*)
 312                        usage ;;
 313                esac
 314                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
 315                do_merge=t
 316                ;;
 317        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 318                --strateg=*|--strategy=*|\
 319        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 320                case "$#,$1" in
 321                *,*=*)
 322                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 323                1,*)
 324                        usage ;;
 325                *)
 326                        strategy="$2"
 327                        shift ;;
 328                esac
 329                do_merge=t
 330                ;;
 331        -n|--no-stat)
 332                diffstat=
 333                ;;
 334        --stat)
 335                diffstat=t
 336                ;;
 337        -v|--verbose)
 338                verbose=t
 339                diffstat=t
 340                GIT_QUIET=
 341                ;;
 342        -q|--quiet)
 343                GIT_QUIET=t
 344                git_am_opt="$git_am_opt -q"
 345                verbose=
 346                diffstat=
 347                ;;
 348        --whitespace=*)
 349                git_am_opt="$git_am_opt $1"
 350                case "$1" in
 351                --whitespace=fix|--whitespace=strip)
 352                        force_rebase=t
 353                        ;;
 354                esac
 355                ;;
 356        --ignore-whitespace)
 357                git_am_opt="$git_am_opt $1"
 358                ;;
 359        --committer-date-is-author-date|--ignore-date)
 360                git_am_opt="$git_am_opt $1"
 361                force_rebase=t
 362                ;;
 363        -C*)
 364                git_am_opt="$git_am_opt $1"
 365                ;;
 366        --root)
 367                rebase_root=t
 368                ;;
 369        -f|--f|--fo|--for|--forc|--force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
 370                force_rebase=t
 371                ;;
 372        --rerere-autoupdate|--no-rerere-autoupdate)
 373                allow_rerere_autoupdate="$1"
 374                ;;
 375        -*)
 376                usage
 377                ;;
 378        *)
 379                break
 380                ;;
 381        esac
 382        shift
 383done
 384test $# -gt 2 && usage
 385
 386if test $# -eq 0 && test -z "$rebase_root"
 387then
 388        test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
 389        test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
 390                die 'A rebase is in progress, try --continue, --skip or --abort.'
 391fi
 392
 393# Make sure we do not have $GIT_DIR/rebase-apply
 394if test -z "$do_merge"
 395then
 396        if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
 397        then
 398                rmdir "$GIT_DIR"/rebase-apply
 399        else
 400                echo >&2 '
 401It seems that I cannot create a rebase-apply directory, and
 402I wonder if you are in the middle of patch application or another
 403rebase.  If that is not the case, please
 404        rm -fr '"$GIT_DIR"'/rebase-apply
 405and run me again.  I am stopping in case you still have something
 406valuable there.'
 407                exit 1
 408        fi
 409else
 410        if test -d "$dotest"
 411        then
 412                die "previous rebase directory $dotest still exists." \
 413                        'Try git rebase (--continue | --abort | --skip)'
 414        fi
 415fi
 416
 417# The tree must be really really clean.
 418if ! git update-index --ignore-submodules --refresh > /dev/null; then
 419        echo >&2 "cannot rebase: you have unstaged changes"
 420        git diff-files --name-status -r --ignore-submodules -- >&2
 421        exit 1
 422fi
 423diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
 424case "$diff" in
 425?*)     echo >&2 "cannot rebase: your index contains uncommitted changes"
 426        echo >&2 "$diff"
 427        exit 1
 428        ;;
 429esac
 430
 431if test -z "$rebase_root"
 432then
 433        # The upstream head must be given.  Make sure it is valid.
 434        upstream_name="$1"
 435        shift
 436        upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 437        die "invalid upstream $upstream_name"
 438        unset root_flag
 439        upstream_arg="$upstream_name"
 440else
 441        test -z "$newbase" && die "--root must be used with --onto"
 442        unset upstream_name
 443        unset upstream
 444        root_flag="--root"
 445        upstream_arg="$root_flag"
 446fi
 447
 448# Make sure the branch to rebase onto is valid.
 449onto_name=${newbase-"$upstream_name"}
 450case "$onto_name" in
 451*...*)
 452        if      left=${onto_name%...*} right=${onto_name#*...} &&
 453                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 454        then
 455                case "$onto" in
 456                ?*"$LF"?*)
 457                        die "$onto_name: there are more than one merge bases"
 458                        ;;
 459                '')
 460                        die "$onto_name: there is no merge base"
 461                        ;;
 462                esac
 463        else
 464                die "$onto_name: there is no merge base"
 465        fi
 466        ;;
 467*)
 468        onto=$(git rev-parse --verify "${onto_name}^0") || exit
 469        ;;
 470esac
 471
 472# If a hook exists, give it a chance to interrupt
 473run_pre_rebase_hook "$upstream_arg" "$@"
 474
 475# If the branch to rebase is given, that is the branch we will rebase
 476# $branch_name -- branch being rebased, or HEAD (already detached)
 477# $orig_head -- commit object name of tip of the branch before rebasing
 478# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 479switch_to=
 480case "$#" in
 4811)
 482        # Is it "rebase other $branchname" or "rebase other $commit"?
 483        branch_name="$1"
 484        switch_to="$1"
 485
 486        if git show-ref --verify --quiet -- "refs/heads/$1" &&
 487           branch=$(git rev-parse -q --verify "refs/heads/$1")
 488        then
 489                head_name="refs/heads/$1"
 490        elif branch=$(git rev-parse -q --verify "$1")
 491        then
 492                head_name="detached HEAD"
 493        else
 494                usage
 495        fi
 496        ;;
 497*)
 498        # Do not need to switch branches, we are already on it.
 499        if branch_name=`git symbolic-ref -q HEAD`
 500        then
 501                head_name=$branch_name
 502                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 503        else
 504                head_name="detached HEAD"
 505                branch_name=HEAD ;# detached
 506        fi
 507        branch=$(git rev-parse --verify "${branch_name}^0") || exit
 508        ;;
 509esac
 510orig_head=$branch
 511
 512# Now we are rebasing commits $upstream..$branch (or with --root,
 513# everything leading up to $branch) on top of $onto
 514
 515# Check if we are already based on $onto with linear history,
 516# but this should be done only when upstream and onto are the same.
 517mb=$(git merge-base "$onto" "$branch")
 518if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 519        # linear history?
 520        ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
 521then
 522        if test -z "$force_rebase"
 523        then
 524                # Lazily switch to the target branch if needed...
 525                test -z "$switch_to" || git checkout "$switch_to"
 526                say "Current branch $branch_name is up to date."
 527                exit 0
 528        else
 529                say "Current branch $branch_name is up to date, rebase forced."
 530        fi
 531fi
 532
 533# Detach HEAD and reset the tree
 534say "First, rewinding head to replay your work on top of it..."
 535git checkout -q "$onto^0" || die "could not detach HEAD"
 536git update-ref ORIG_HEAD $branch
 537
 538if test -n "$diffstat"
 539then
 540        if test -n "$verbose"
 541        then
 542                echo "Changes from $mb to $onto:"
 543        fi
 544        # We want color (if set), but no pager
 545        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 546fi
 547
 548# If the $onto is a proper descendant of the tip of the branch, then
 549# we just fast-forwarded.
 550if test "$mb" = "$branch"
 551then
 552        say "Fast-forwarded $branch_name to $onto_name."
 553        move_to_original_branch
 554        exit 0
 555fi
 556
 557if test -n "$rebase_root"
 558then
 559        revisions="$onto..$orig_head"
 560else
 561        revisions="$upstream..$orig_head"
 562fi
 563
 564if test -z "$do_merge"
 565then
 566        git format-patch -k --stdout --full-index --ignore-if-in-upstream \
 567                --src-prefix=a/ --dst-prefix=b/ \
 568                --no-renames $root_flag "$revisions" |
 569        git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
 570        move_to_original_branch
 571        ret=$?
 572        test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
 573                echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
 574                echo $onto > "$GIT_DIR"/rebase-apply/onto &&
 575                echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
 576                echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
 577        exit $ret
 578fi
 579
 580# start doing a rebase with git-merge
 581# this is rename-aware if the recursive (default) strategy is used
 582
 583mkdir -p "$dotest"
 584echo "$onto" > "$dotest/onto"
 585echo "$onto_name" > "$dotest/onto_name"
 586prev_head=$orig_head
 587echo "$prev_head" > "$dotest/prev_head"
 588echo "$orig_head" > "$dotest/orig-head"
 589echo "$head_name" > "$dotest/head-name"
 590echo "$GIT_QUIET" > "$dotest/quiet"
 591
 592msgnum=0
 593for cmt in `git rev-list --reverse --no-merges "$revisions"`
 594do
 595        msgnum=$(($msgnum + 1))
 596        echo "$cmt" > "$dotest/cmt.$msgnum"
 597done
 598
 599echo 1 >"$dotest/msgnum"
 600echo $msgnum >"$dotest/end"
 601
 602end=$msgnum
 603msgnum=1
 604
 605while test "$msgnum" -le "$end"
 606do
 607        call_merge "$msgnum"
 608        continue_merge
 609done
 610
 611finish_rb_merge